var all_artists = null;  			//array containing all retrieved artists from iTunes
var excluded_artists = null;		//array containing the names of all artists NOT to be search for
var cds = null;								//array containing all 'new' cds

var curArtist;									//interger representing the current index in all_artists in the search
var cdsAdded;
var tooOld;											//number of days before an album is considered 'too old', set in preferences
var oldContent;									//used to store the previously listed div so it can be hidden

var scrollbar, scrollArea;		 	//scroll objects
var gDoneButton, gInfoButton; 	//buttons 

var lastStatus;									//string containing the last system status displayed
var displayingToolTip;					//boolean if a mouseover tool tip is being displayed

function setup()
{
	//set iup the scroll bar
	scrollbar = new AppleVerticalScrollbar(document.getElementById("myScrollBar"));
	scrollArea = new AppleScrollArea(document.getElementById("scrollArea"), scrollbar);
	scrollArea.scrollsHorizontally = false;
	scrollArea.singlepressScrollPixels = 25;
	scrollArea.focus(); // for key control when first loading
	
	window.onfocus = function () { scrollArea.focus(); }
	window.onblur = function () { scrollArea.blur(); }
	
	document.getElementById("resultsList").style.display = 'block';
	
	//set up the info and back buttons
	gDoneButton = new AppleGlassButton(document.getElementById("doneButton"), "Done", hidePrefs);
  gInfoButton = new AppleInfoButton(document.getElementById("infoButton"), document.getElementById("front"), "white", "white",showPrefs);
	if (window.widget)
  {
  	widget.onshow = onshow;
		widget.onhide = onhide;
		widget.onremove = removalHandler;
  }
	
	//add tool tip info
	addToolTip(document.getElementById("ImportButton"), "Import artists from iTunes.");
	addToolTip(document.getElementById("SearchButton"), "Search for new albums.");
	
	displayingToolTip = false;
	
	loadPrefs();
	showAllResults();
}

//---------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------
function showArtists()
{
	updateImages("ArtistButton");
	showContent(document.getElementById("artistList"));
}

//---------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------
function showAllResults()
{
	updateImages("AllButton");
	showContent(document.getElementById("resultsList"));
}

//---------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------
function onshow(){
	//stub
}

//---------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------
function onhide(){
	if(inSearch && !searchPaused && !backgroundSearches){
		pauseSearch();
	}
	savePrefs();
}

//---------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------
function removalHandler(){
	if(inSearch){
		cancelSearch();
	}
	widget.setPreferenceForKey(null,"age");
	widget.setPreferenceForKey(null,"artists");
	widget.setPreferenceForKey(null,"cds");
	widget.setPreferenceForKey(null,"excluded");
	widget.setPreferenceForKey(null,"bgs");
}

//---------------------------------------------------------------------------------------------
// updates all button displays
//----------------------------------------------------------------------------------------------
function updateImages(button)
{
	document.getElementById("ArtistButton").src = "images/button.png";
	document.getElementById("AllButton").src = "images/button.png";

	document.getElementById(button).src = "images/button-pressed.png";
}

//---------------------------------------------------------------------------------------------
//displays a div tag, either artists or albums
//---------------------------------------------------------------------------------------------
function showContent(newContent){
	if (oldContent != null) {
		oldContent.style.display = 'none';
	}
	newContent.style.display = 'block';
	
	scrollArea.reveal(newContent);
	scrollArea.refresh();

	oldContent = newContent;
}

//---------------------------------------------------------------------------------------------
// parses local iTunes data for a list of artists using a custom AppleScript
// Then loads the artists into a globar array
//----------------------------------------------------------------------------------------------
function refreshArtists()
{
	loadLibrary();
/*
	if(inSearch){
		setStatus("Cancel the search before performing this action.");
	}else{
		//loadLibrary();
		//update status and fetch the artists
		setStatus("Fetching artists from iTunes.");
		var raw = widget.system("/usr/bin/osascript iTunesGrabber.scpt", null).outputString;
		setStatus("Sorting Artist List"); 

		//load and construct the artists list	
		loadArtistsFromString(raw);
		
		constructArtistList();
	}
	*/
}
//---------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------
function loadArtistsFromString(artists){
	//parse out goofy characters
	artists = artists.replace(/(<|>|\/|'|"|{|}|\[|\]|,)/g,  " ");
	all_artists = artists.split("!SPLIT!");
	all_artists.pop();  //kill the trailing empty entry
	all_artists.sort(mySort);
	setStatus("Loaded " + all_artists.length + " artists."); 
}

function mySort(a,b)
{
		var A = a.toLowerCase().replace(/^the /gi, "");
		var B = b.toLowerCase().replace(/^the /gi, "");
		if (A < B) 
			return -1;
		if (A > B) 
			return 1;
		
		return 0;
}
//---------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------
function constructArtistList(){
	var artistList = document.getElementById("artistList")
	deleteChildren(artistList);
	for(var i = 0; i < all_artists.length; i++){
		var artistDiv = document.createElement("div");
		var id = "artist-" + i;
		//this argument contains both the artist name and the id of the div containing that artist
		//seperated by !#! which is a (hopefully) unique string that will be used to split the 2 apart
		//bands, please do not name yourself !#!, thanks.
		var toggleArgument = all_artists[i] + "!#!" + id;
		artistDiv.setAttribute("id", id);
		artistDiv.setAttribute("class", i%2 == 0 ? 'artistEven' : 'artistOdd');
		artistDiv.setAttribute("onclick", "toggleArtistInclude('" + toggleArgument + "');");
		addToolTip(artistDiv, "Click to exclude artist from search.");
		artistDiv.innerText = all_artists[i];
		
		var toggle = document.createElement("div");
		toggle.setAttribute("class", "artistExclude");
		toggle.setAttribute("id", "toggle" + id);
		
		toggle.innerHTML = isIncluded(all_artists[i]) ? "<img src='images/checked.png'/>" : "<img src='images/unchecked.png'/>";
		artistDiv.appendChild(toggle);
		
		document.getElementById("artistList").appendChild(artistDiv);
	}
	scrollArea.refresh();
}

//---------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------
function constructResults(start, end){
	var listSpace = document.getElementById("resultsList");
	for(i = start; i < end; i++){
		var cd = cds[i];
		
		var id = getUniqueIDforCD(cd);
		//do not allow duplicate entries
		if(!document.getElementById(id)){
			cdsAdded++;
			var cdDiv = document.createElement("div");
			cdDiv.setAttribute("id", id);
			cdDiv.setAttribute("class", cdsAdded%2 == 0 ? 'cdOdd' : 'cdEven');
			cdDiv.innerHTML = "Artist: " + cd.artist + "<br/>Title: " + cd.title + "<br/>Date: " + textDate(cd.date);
			
			var entryOptions = document.createElement("div");
			entryOptions.setAttribute("class", "cdOptions");
		
			var buy = document.createElement("span");
			buy.setAttribute("onclick","clicked('" + cd.url + "');");
			buy.setAttribute("class", "entryBuy");
			buy.innerText = "$";
			addToolTip(buy, "Buy this cd.");
			entryOptions.appendChild(buy);
		
			var remove = document.createElement("span");
			remove.setAttribute("onclick", "removeEntry('" + id + "');");
			remove.setAttribute("class", "entryDelete");
			remove.innerText = "x";
			addToolTip(remove, "Delete this entry.");
			entryOptions.appendChild(remove);
			
			cdDiv.appendChild(entryOptions);
			listSpace.appendChild(cdDiv);
		}
	}
	scrollArea.refresh();
}

//---------------------------------------------------------------------------------------------
//make an id for a div that will (should) be different for every cd
//---------------------------------------------------------------------------------------------
function getUniqueIDforCD(cd){
	return cd.title.replace(/(<|>|\/|'|"|{|}|\[|\]|,)/g, "_") + "#" + cd.date;
}

//---------------------------------------------------------------------------------------------
// Returns true if the date is new enough to be considered a new release
//---------------------------------------------------------------------------------------------
function isNew(date){
	if(date == "")
		return false;
	var yearMonthDay = date.split("-");
	var today = new Date();
	var daysApart = ( Date.UTC(today.getFullYear(), today.getMonth()+1, today.getDate()) - 
										 Date.UTC(yearMonthDay[0], yearMonthDay[1], yearMonthDay[2]) )/1000/60/60/24;
	return daysApart < tooOld;
}

//---------------------------------------------------------------------------------------------
// returns true if the artist is included in the list
//---------------------------------------------------------------------------------------------
function isIncluded(artist){
	for(var i = 0; i < excluded_artists.length; i++){
		if(artist == excluded_artists[i]){
			return false;
		}
	}
	return true;
}

//---------------------------------------------------------------------------------------------
// Methods to handle status updates and tooltip rollovers
//---------------------------------------------------------------------------------------------
function setStatus(status){
	lastStatus = status;
	if(!displayingToolTip){
		document.getElementById("status").innerText = status;
	}
}
function showToolTip(status){
	displayingToolTip = true;
	lastStatus = document.getElementById("status").innerText;
	document.getElementById("status").innerText = status;
}
function hideToolTip(){
	displayingToolTip = false;
	setStatus(lastStatus);
}

//---------------------------------------------------------------------------------------------
// open an external browser with the given url
//---------------------------------------------------------------------------------------------
function clicked(url){
	if(widget)
		widget.openURL(url);
}

//---------------------------------------------------------------------------------------------
// toggles if an artist is included in the list or not
//---------------------------------------------------------------------------------------------
function toggleArtistInclude(arg){
	if(inSearch) 
		return;
	var artistAndId = arg.split("!#!");
	var artist = artistAndId[0];
	var id = artistAndId[1];
	//deal with manipulating the excluded array
	var included = false;
	for(var i = 0; i < excluded_artists.length; i++){
		if(artist == excluded_artists[i]){
			//remove the artist from being excluded
			excluded_artists.splice(i,1);
			included = true;
			break;
		}
	}
	if(!included){
		excluded_artists.push(artist);
	}
	var entry = document.getElementById(id);
	var imageDiv = document.getElementById("toggle"+id);
	if(included){
		imageDiv.innerHTML = "<img src='images/checked.png'>";
		entry.setAttribute("onmouseover",entry.getAttribute("onmouseover").replace(/include/, "exclude"));
		entry.setAttribute("onmouseover",entry.getAttribute("onmouseover").replace(/in/, "from"));
	}else{
		imageDiv.innerHTML = "<img src='images/unchecked.png'>";
		entry.setAttribute("onmouseover", entry.getAttribute("onmouseover").replace(/exclude/, "include"));
		entry.setAttribute("onmouseover",entry.getAttribute("onmouseover").replace(/from/, "in"));
	}
	eval(entry.getAttribute("onmouseover"));
}

//---------------------------------------------------------------------------------------------
// removes a cd entry from the list and also deletes it from the array of cds
//---------------------------------------------------------------------------------------------
function removeEntry(id){
	if(inSearch)
		return;
	var child = document.getElementById(id);
	var next = child.nextSibling;
	while(next){
		var whichClass = next.getAttribute('class');
		if(whichClass == "cdOdd"){
			next.setAttribute("class", "cdEven");
		}else{
			next.setAttribute("class", "cdOdd");
		}
		next = next.nextSibling;
	}
	for(var i = 0; i < cds.length; i++){
		if(id == getUniqueIDforCD(cds[i])){
			cds.splice(i,1);
			displayingToolTip = false;
			setStatus("Entry deleted");
		}
	}
	document.getElementById("resultsList").removeChild(child);
	
	scrollArea.refresh();
	scrollbar.refresh();
}

//---------------------------------------------------------------------------------------------
// validates text as containing only numbers
//---------------------------------------------------------------------------------------------
function isNumeric(text){
	var nums = "0123456789";
	for (i = 0; i < text.length; i++){ 
		if (nums.indexOf(text.charAt(i)) == -1){
 			return false;
		}
	}
	return true;
}

//---------------------------------------------------------------------------------------------
// return the english equivalent of a date from Amazon
//---------------------------------------------------------------------------------------------
function textDate(date){
	var yearMonthDay = date.split("-");
	var monthText;
	switch(yearMonthDay[1]){
		case "01": 
			monthText = "January"; break;
		case "02": 
			monthText = "February"; break;
		case "03": 
			monthText = "March"; break;
		case "04": 
			monthText = "April"; break;
		case "05": 
			monthText = "May"; break;
		case "06": 
			monthText = "June"; break;
		case "07": 
			monthText = "July"; break;
		case "08": 
			monthText = "August"; break;
		case "09": 
			monthText = "September"; break;
		case "10": 
			monthText = "October"; break;
		case "11": 
			monthText = "November"; break;
		default:
			monthText = "December";
	}
	return monthText + " " + yearMonthDay[2] + ", " + yearMonthDay[0];
}

//---------------------------------------------------------------------------------------------
// Fix the display for changing search status
//---------------------------------------------------------------------------------------------
function displaySearching(searching){
	var search_btn = document.getElementById("SearchButton");
	if(searching){
		//change the search button to cancel
		setStatus("Search initiated.");
		search_btn.setAttribute("src", "images/searchCancel_hl.png");
		search_btn.setAttribute("onmouseover",'this.src="images/searchCancel_hl.png";');
		search_btn.setAttribute("onmouseout",'this.src="images/searchCancel.png";');
		search_btn.setAttribute("onclick",'cancelSearch();');
		addToolTip(search_btn, "Cancel search");
		
		//add the pause button
		var pause_btn = document.createElement("img");
		pause_btn.setAttribute("id", "PauseButton");
		pause_btn.setAttribute("src",'images/searchPaused.png');
		pause_btn.setAttribute("onmouseover",'this.src="images/searchPaused_hl.png";');
		pause_btn.setAttribute("onmouseout",'this.src="images/searchPaused.png";');
		pause_btn.setAttribute("onclick",'pauseSearch();');
		addToolTip(pause_btn, "Pause search.");	
		document.getElementById("front").appendChild(pause_btn);
		
		enableImport(false);
		enableArtistToggle(false);
	}else{
		setStatus("Search cancelled.");
		search_btn.setAttribute("src",'images/search_hl.png');
		search_btn.setAttribute("onmouseover", "this.src='images/search_hl.png';");
		search_btn.setAttribute("onmouseout", "this.src='images/search.png';");
		search_btn.setAttribute("onclick", "initSearch();");
		addToolTip(search_btn, "Search for new albums.");	
		
		enableImport(true);
		enableArtistToggle(true);
		//delete the pause button
		var pause_btn = document.getElementById("PauseButton");
		document.getElementById("front").removeChild(pause_btn);
	}
}

//---------------------------------------------------------------------------------------------
// Display for a finished search
//---------------------------------------------------------------------------------------------
function displayFinished(){
	var search_btn = document.getElementById("SearchButton");
	var pause_btn = document.getElementById("PauseButton");
	search_btn.setAttribute("src",'images/search.png');
	search_btn.setAttribute("onmouseover", "this.src='images/search_hl.png';");
	search_btn.setAttribute("onmouseout", "this.src='images/search.png';");
	search_btn.setAttribute("onclick", "initSearch();");	
	addToolTip(search_btn, "Search for new albums.");
	//delete the pause button
	document.getElementById("front").removeChild(pause_btn);
	
	enableImport(true);
	enableArtistToggle(true);
}

function enableImport(enabled){
	import_btn = document.getElementById("ImportButton");
	if(enabled){
		//enable the import button
		import_btn.setAttribute("src", "images/import.png");
		import_btn.setAttribute("onmouseover", "this.src='images/import_hl.png';");
		import_btn.setAttribute("onmouseout", "this.src='images/import.png';");
		import_btn.setAttribute("onclick", "refreshArtists();");
		addToolTip(import_btn, "Import artists from iTunes.");
	}else{
		//disable the import button
		import_btn.setAttribute("src", "images/import_ds.png");
		import_btn.setAttribute("onmouseover", "this.src='images/import_ds.png';");
		import_btn.setAttribute("onmouseout", "this.src='images/import_ds.png';");
		import_btn.setAttribute("onclick", "");
	}
}

function enableArtistToggle(enabled){
	var list = document.getElementById("artistList");
	var children = list.getElementsByTagName("img");
	for(var i = 0; i < children.length; i++){
		var img = children[i];
		var child = document.getElementById("artist-" + i);
		if(!enabled){
			if(img.getAttribute("src") == "images/checked.png"){
				img.src = "images/check_ds.png";
			}
			removeToolTip(child);

		}else{
			if(img.getAttribute("src") == "images/check_ds.png"){
				img.src = "images/checked.png";
				addToolTip(child, "Click to exclude artist from search.");
			}else{
				addToolTip(child, "Click to include artist in search.");
			}
		}
	}
}

//---------------------------------------------------------------------------------------------
// Update pause status
//---------------------------------------------------------------------------------------------
function displayPaused(paused){
	var button = document.getElementById("PauseButton");
	if(paused){
		setStatus("Search paused.");
		button.setAttribute("onclick", 'resumeSearch();');
		button.setAttribute("src",'images/searchPlay_hl.png');
		button.setAttribute("onmouseover", "this.src='images/searchPlay_hl.png';");
		button.setAttribute("onmouseout", "this.src='images/searchPlay.png';");
		addToolTip(button, "Resume search.");
	}else{
		setStatus("Search resumed.");
		button.setAttribute("onclick",'pauseSearch();');
		button.setAttribute("src",'images/searchPaused_hl.png');
		button.setAttribute("onmouseover", "this.src='images/searchPaused_hl.png';");
		button.setAttribute("onmouseout", "this.src='images/searchPaused.png';");
		addToolTip(button, "Pause search.");
	}
}

//---------------------------------------------------------------------------------------------
// adds a rollover tool tip to an object
// pre: any other tooltips have been removed with removeToolTip
// post: mouseover the obj will cause the text to be displayed
//---------------------------------------------------------------------------------------------
function addToolTip(obj, text){
	var curMouseOver = obj.getAttribute('onmouseover');
	var curMouseOut = obj.getAttribute('onmouseout');
	if(!curMouseOver){
		curMouseOver = "";
	}
	if(!curMouseOut){
		curMouseOut = "";
	}
	obj.setAttribute("onmouseover", curMouseOver + " showToolTip('" + text + "');");
	obj.setAttribute("onmouseout", curMouseOut + " hideToolTip();");
}

function removeToolTip(obj){
	obj.setAttribute("onmouseover", obj.getAttribute("onmouseover").replace(/showToolTip(.*);/, ""));
	obj.setAttribute("onmouseout", obj.getAttribute("onmouseout").replace(/hideToolTip();/, ""));
}

function deleteChildren(obj){
	while (obj.firstChild){
    obj.removeChild(obj.firstChild);
 	}
}