var inSearch = false;
var searchPaused = false;
var tagObjects = null;
var artistsInSearch = null;
var searchTimer, displayTimer;
// JSON ScriptBuilder Function and Prototype, from Jason Levitt of Yahoo!
// code found here: http://devx.com/webdev/Article/30860/1954
function JSONscriptRequest(fullUrl) {
	this.fullUrl = fullUrl;
	this.headLoc = document.getElementsByTagName("head").item(0);
	this.scriptId = 'azScriptId' + JSONscriptRequest.scriptCounter++;
}

JSONscriptRequest.scriptCounter = 1;

JSONscriptRequest.prototype.buildScriptTag = function () {
	this.scriptObj = document.createElement("script");
	this.scriptObj.setAttribute("type", "text/javascript");
	this.scriptObj.setAttribute("src", this.fullUrl);
	this.scriptObj.setAttribute("id", this.scriptId);
	this.scriptObj.setAttribute("charset","utf-8");
}

JSONscriptRequest.prototype.removeScriptTag = function () {
	this.headLoc.removeChild(this.scriptObj);
}

JSONscriptRequest.prototype.addScriptTag = function () {
	this.headLoc.appendChild(this.scriptObj);
}

function initSearch(){
	if(all_artists != null){
		//get it going
		displaySearching(true);
		inSearch = true;
		cds = new Array();
		tagObjects = new Array();
		//get a list of artists to be searched for
		artistsInSearch = new Array();
		for(var i = 0; i < all_artists.length; i++){
			if(isIncluded(all_artists[i])){
				artistsInSearch[artistsInSearch.length] = all_artists[i];
			}
		}
		deleteChildren(document.getElementById("resultsList"));
		scrollArea.refresh();
		cdsAdded = 0;
		curArtist = 0;
		nextQuery();
	}
}

function cancelSearch(){
	if(inSearch){
		if(searchTimer != null){
			clearTimeout(searchTimer);
		}
		if(displayTimer != null){
			clearTimeout(displayTimer);
		}
		inSearch = false;
		searchPaused = false;
		displaySearching(false);
		deleteScriptTags();
	}
}

function pauseSearch(){
	if(inSearch && !searchPaused)
		if(searchTimer != null){
			clearTimeout(searchTimer);
			curArtist -= 2;
		}
		if(displayTimer != null){
			clearTimeout(displayTimer);
		}
		
		searchPaused = true;
		displayPaused(true);
}

function resumeSearch(){
	if(inSearch && searchPaused){
		searchPaused = false;
		displayPaused(false);
		nextQuery();
	}
}

// Callback function referenced by the JSON script
var amzJSONCallback = function(tmpData){
	if(!inSearch)
		return;
	var start = cds.length;
	if(!searchPaused){
		for(i = 0; i < tmpData.ItemSet.Item.length-1; i++){
			var cd = tmpData.ItemSet.Item[i];
			if(isNew(cd.date)){
				cds[cds.length] = cd;
			}
		}
		constructResults(start, cds.length);
		//remove script tag for this entry, it is not needed
		if(tagObjects[tagObjects.length-1]){
			tagObjects[tagObjects.length-1].removeScriptTag();
			tagObjects.splice(tagObjects.length-1,1);
		}
	}else{
		//this guy was left hanging, we need to backtrack to include that artist
		curArtist--;
	}
}

function nextQuery(){
	if(inSearch && !searchPaused){
		if(curArtist < artistsInSearch.length - 1){
			searchTimer = setTimeout("amazonSearch('" + artistsInSearch[curArtist++] +"', '" + artistsInSearch[curArtist++] + "' ); nextQuery();",1000);
		}else if(curArtist < artistsInSearch.length){
			searchTimer = setTimeout("amazonSearch('" + artistsInSearch[curArtist++] +"', null); nextQuery();", 1000);
		}else{
			clearTimeout(displayTimer);
			inSearch = false;
			displayFinished();
			deleteScriptTags();
			setStatus(cds.length + " new albums found!");
		}
	}
}

// Search function - creates, builds, and adds remote JSON script
// to the page, which in turn calls amzJSONCallback
amazonSearch = function(artist, artist2){
	if(!inSearch)
		return;
	if(!searchPaused){	
		setStatus("updating: " + artist);
		if(artist2 == null){
			var request = 'http://xml-us.amznxslt.com/onca/xml?Service=AWSECommerceService&SubscriptionId=03QESZKGGC06TC13YAG2&AssociateTag=jimgeorgecom-20&Operation=ItemSearch&SearchIndex=Music&Artist=' + artist +'&ResponseGroup=Medium&Style=http://jim-george.com/newTunes/xsl/newTunes-1.2.xsl&ContentType=text/javascript&CallBack=amzJSONCallback';
		}else{
			displayTimer = setTimeout("setStatus('updating: " + artist2 + "');", 500);
			var request = 'http://xml-us.amznxslt.com/onca/xml?Service=AWSECommerceService&SubscriptionId=03QESZKGGC06TC13YAG2&AssociateTag=jimgeorgecom-20&Operation=ItemSearch&ItemSearch.Shared.SearchIndex=Music&ItemSearch.1.Artist=' + artist +'&ItemSearch.2.Artist=' + artist2 +'&ResponseGroup=Medium&Style=http://jim-george.com/newTunes/xsl/newTunes-1.2.xsl&ContentType=text/javascript&CallBack=amzJSONCallback';
		}
		aObj = new JSONscriptRequest(request);
		aObj.buildScriptTag();
		aObj.addScriptTag();
		tagObjects[tagObjects.length] = aObj;
	}else{
		//one or two artists were left hanging
		curArtist--;
		if(artist2 != null)
			curArtist--;
	}
}

function deleteScriptTags(){
	var head = document.getElementsByTagName("head").item(0);
	for(var i = 0; i < tagObjects.length; i++){
		tagObjects[i].removeScriptTag();
	}
}